#import <UIKit/UIKit.h>

@interface Particle : UIView {
    UIImageView *particle;
    double x;
    double y;
    double rX;
    double rY;
    float alpha;
    int lifetime;
    int step;
    double gravity;
    double wind;
    int width;
    int height;
    bool lifetimeHasEnded;
}

@property (nonatomic, strong) UIImageView *particle;

- (id) initParticleAt: (double) posX
                    y: (double) posY
                width: (double) w
               height: (double) h
                alpha: (double) a
             lifetime: (double) l
              gravity: (double) g
                 wind: (double) wx
                   rX: (double) rx
                   rY: (double) ry
                  col: (UIColor*) color
           parentView: (UIView*) parentView;

- (void) setParticleImage: (UIImage*) img;
- (void) go;

- (bool) detectCollisionWithFrame: (CGRect) sprite;
- (CGRect) frame;
- (CGPoint) center;
- (bool) lifetimeHasEnded;
- (void) die;

@end