#import <UIKit/UIKit.h>

@interface Sprite : UIView {
    UIImageView *pic;
    NSMutableArray *mask;
    int spriteTyp;
    int movingDirection;
    int sId;
    int shieldPower;
}

@property (nonatomic, strong) UIImageView *pic;
@property (nonatomic, strong) NSMutableArray *mask;

- (id) initWithImage: (UIImage *) img
           spriteTyp: (double) sTyp
          parentView: (UIView*) parentView;

- (void) addMask: (double) x
               y:(double) y
           width:(double)width
          height:(double)height;

- (void) setSpriteTyp: (UIImage *) img
                  typ: (int) sTyp;

- (void) setAnimationTyp: (NSArray *) img
               spriteTyp: (int) sTyp
                duration: (double) duration
                  repeat: (int) repeat;

- (void) moveBy: (double) x
              y: (double) y;

- (void) setCenter: (double) x
                 y: (double) y;

- (bool) detectCollisionWith: (Sprite *) sprite;
- (bool) detectCollisionWithMask: (Sprite *) sprite;

- (CGRect) frame;
- (CGPoint) center;
- (int) spriteTyp;
- (int) movingDirection;
- (void) changeMovingDirection;
- (void) setAlpha: (float) a;
- (void) mirrorSprite: (int) a;
- (void) setId: (int) a;
- (int) sId;
- (void) setShieldPower: (int) a;
- (int) shieldPower;

@end